gitweb: Protect escaping functions against calling on undef
[git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
22
23 Example:       git-rebase master~1 topic
24
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
29
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
36
37 LF='
38 '
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset newbase
46 strategy=recursive
47 do_merge=
48 dotest="$GIT_DIR"/rebase-merge
49 prec=4
50 verbose=
51 diffstat=$(git config --bool rebase.stat)
52 git_am_opt=
53 rebase_root=
54 force_rebase=
55 allow_rerere_autoupdate=
56
57 continue_merge () {
58         test -n "$prev_head" || die "prev_head must be defined"
59         test -d "$dotest" || die "$dotest directory does not exist"
60
61         unmerged=$(git ls-files -u)
62         if test -n "$unmerged"
63         then
64                 echo "You still have unmerged paths in your index"
65                 echo "did you forget to use git add?"
66                 die "$RESOLVEMSG"
67         fi
68
69         cmt=`cat "$dotest/current"`
70         if ! git diff-index --quiet --ignore-submodules HEAD --
71         then
72                 if ! git commit --no-verify -C "$cmt"
73                 then
74                         echo "Commit failed, please do not call \"git commit\""
75                         echo "directly, but instead do one of the following: "
76                         die "$RESOLVEMSG"
77                 fi
78                 if test -z "$GIT_QUIET"
79                 then
80                         printf "Committed: %0${prec}d " $msgnum
81                 fi
82         else
83                 if test -z "$GIT_QUIET"
84                 then
85                         printf "Already applied: %0${prec}d " $msgnum
86                 fi
87         fi
88         test -z "$GIT_QUIET" &&
89         GIT_PAGER='' git log --format=%s -1 "$cmt"
90
91         prev_head=`git rev-parse HEAD^0`
92         # save the resulting commit so we can read-tree on it later
93         echo "$prev_head" > "$dotest/prev_head"
94
95         # onto the next patch:
96         msgnum=$(($msgnum + 1))
97         echo "$msgnum" >"$dotest/msgnum"
98 }
99
100 call_merge () {
101         cmt="$(cat "$dotest/cmt.$1")"
102         echo "$cmt" > "$dotest/current"
103         hd=$(git rev-parse --verify HEAD)
104         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
105         msgnum=$(cat "$dotest/msgnum")
106         end=$(cat "$dotest/end")
107         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
108         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
109         export GITHEAD_$cmt GITHEAD_$hd
110         if test -n "$GIT_QUIET"
111         then
112                 export GIT_MERGE_VERBOSITY=1
113         fi
114         git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
115         rv=$?
116         case "$rv" in
117         0)
118                 unset GITHEAD_$cmt GITHEAD_$hd
119                 return
120                 ;;
121         1)
122                 git rerere $allow_rerere_autoupdate
123                 die "$RESOLVEMSG"
124                 ;;
125         2)
126                 echo "Strategy: $rv $strategy failed, try another" 1>&2
127                 die "$RESOLVEMSG"
128                 ;;
129         *)
130                 die "Unknown exit code ($rv) from command:" \
131                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
132                 ;;
133         esac
134 }
135
136 move_to_original_branch () {
137         test -z "$head_name" &&
138                 head_name="$(cat "$dotest"/head-name)" &&
139                 onto="$(cat "$dotest"/onto)" &&
140                 orig_head="$(cat "$dotest"/orig-head)"
141         case "$head_name" in
142         refs/*)
143                 message="rebase finished: $head_name onto $onto"
144                 git update-ref -m "$message" \
145                         $head_name $(git rev-parse HEAD) $orig_head &&
146                 git symbolic-ref HEAD $head_name ||
147                 die "Could not move back to $head_name"
148                 ;;
149         esac
150 }
151
152 finish_rb_merge () {
153         move_to_original_branch
154         rm -r "$dotest"
155         say All done.
156 }
157
158 is_interactive () {
159         while test $# != 0
160         do
161                 case "$1" in
162                         -i|--interactive)
163                                 interactive_rebase=explicit
164                                 break
165                         ;;
166                         -p|--preserve-merges)
167                                 interactive_rebase=implied
168                         ;;
169                 esac
170                 shift
171         done
172
173         if [ "$interactive_rebase" = implied ]; then
174                 GIT_EDITOR=:
175                 export GIT_EDITOR
176         fi
177
178         test -n "$interactive_rebase" || test -f "$dotest"/interactive
179 }
180
181 run_pre_rebase_hook () {
182         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
183            test -x "$GIT_DIR/hooks/pre-rebase"
184         then
185                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
186                 die "The pre-rebase hook refused to rebase."
187         fi
188 }
189
190 test -f "$GIT_DIR"/rebase-apply/applying &&
191         die 'It looks like git-am is in progress. Cannot rebase.'
192
193 is_interactive "$@" && exec git-rebase--interactive "$@"
194
195 if test $# -eq 0
196 then
197         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
198         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
199                 die 'A rebase is in progress, try --continue, --skip or --abort.'
200         die "No arguments given and $GIT_DIR/rebase-apply already exists."
201 fi
202
203 while test $# != 0
204 do
205         case "$1" in
206         --no-verify)
207                 OK_TO_SKIP_PRE_REBASE=yes
208                 ;;
209         --continue)
210                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
211                         die "No rebase in progress?"
212
213                 git diff-files --quiet --ignore-submodules || {
214                         echo "You must edit all merge conflicts and then"
215                         echo "mark them as resolved using git add"
216                         exit 1
217                 }
218                 if test -d "$dotest"
219                 then
220                         prev_head=$(cat "$dotest/prev_head")
221                         end=$(cat "$dotest/end")
222                         msgnum=$(cat "$dotest/msgnum")
223                         onto=$(cat "$dotest/onto")
224                         GIT_QUIET=$(cat "$dotest/quiet")
225                         continue_merge
226                         while test "$msgnum" -le "$end"
227                         do
228                                 call_merge "$msgnum"
229                                 continue_merge
230                         done
231                         finish_rb_merge
232                         exit
233                 fi
234                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
235                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
236                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
237                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
238                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
239                 move_to_original_branch
240                 exit
241                 ;;
242         --skip)
243                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
244                         die "No rebase in progress?"
245
246                 git reset --hard HEAD || exit $?
247                 if test -d "$dotest"
248                 then
249                         git rerere clear
250                         prev_head=$(cat "$dotest/prev_head")
251                         end=$(cat "$dotest/end")
252                         msgnum=$(cat "$dotest/msgnum")
253                         msgnum=$(($msgnum + 1))
254                         onto=$(cat "$dotest/onto")
255                         GIT_QUIET=$(cat "$dotest/quiet")
256                         while test "$msgnum" -le "$end"
257                         do
258                                 call_merge "$msgnum"
259                                 continue_merge
260                         done
261                         finish_rb_merge
262                         exit
263                 fi
264                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
265                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
266                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
267                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
268                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
269                 move_to_original_branch
270                 exit
271                 ;;
272         --abort)
273                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
274                         die "No rebase in progress?"
275
276                 git rerere clear
277                 if test -d "$dotest"
278                 then
279                         GIT_QUIET=$(cat "$dotest/quiet")
280                         move_to_original_branch
281                 else
282                         dotest="$GIT_DIR"/rebase-apply
283                         GIT_QUIET=$(cat "$dotest/quiet")
284                         move_to_original_branch
285                 fi
286                 git reset --hard $(cat "$dotest/orig-head")
287                 rm -r "$dotest"
288                 exit
289                 ;;
290         --onto)
291                 test 2 -le "$#" || usage
292                 newbase="$2"
293                 shift
294                 ;;
295         -M|-m|--m|--me|--mer|--merg|--merge)
296                 do_merge=t
297                 ;;
298         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
299                 --strateg=*|--strategy=*|\
300         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
301                 case "$#,$1" in
302                 *,*=*)
303                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
304                 1,*)
305                         usage ;;
306                 *)
307                         strategy="$2"
308                         shift ;;
309                 esac
310                 do_merge=t
311                 ;;
312         -n|--no-stat)
313                 diffstat=
314                 ;;
315         --stat)
316                 diffstat=t
317                 ;;
318         -v|--verbose)
319                 verbose=t
320                 diffstat=t
321                 GIT_QUIET=
322                 ;;
323         -q|--quiet)
324                 GIT_QUIET=t
325                 git_am_opt="$git_am_opt -q"
326                 verbose=
327                 diffstat=
328                 ;;
329         --whitespace=*)
330                 git_am_opt="$git_am_opt $1"
331                 case "$1" in
332                 --whitespace=fix|--whitespace=strip)
333                         force_rebase=t
334                         ;;
335                 esac
336                 ;;
337         --ignore-whitespace)
338                 git_am_opt="$git_am_opt $1"
339                 ;;
340         --committer-date-is-author-date|--ignore-date)
341                 git_am_opt="$git_am_opt $1"
342                 force_rebase=t
343                 ;;
344         -C*)
345                 git_am_opt="$git_am_opt $1"
346                 ;;
347         --root)
348                 rebase_root=t
349                 ;;
350         -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
351                 force_rebase=t
352                 ;;
353         --rerere-autoupdate|--no-rerere-autoupdate)
354                 allow_rerere_autoupdate="$1"
355                 ;;
356         -*)
357                 usage
358                 ;;
359         *)
360                 break
361                 ;;
362         esac
363         shift
364 done
365 test $# -gt 2 && usage
366
367 # Make sure we do not have $GIT_DIR/rebase-apply
368 if test -z "$do_merge"
369 then
370         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
371         then
372                 rmdir "$GIT_DIR"/rebase-apply
373         else
374                 echo >&2 '
375 It seems that I cannot create a rebase-apply directory, and
376 I wonder if you are in the middle of patch application or another
377 rebase.  If that is not the case, please
378         rm -fr '"$GIT_DIR"'/rebase-apply
379 and run me again.  I am stopping in case you still have something
380 valuable there.'
381                 exit 1
382         fi
383 else
384         if test -d "$dotest"
385         then
386                 die "previous rebase directory $dotest still exists." \
387                         'Try git rebase (--continue | --abort | --skip)'
388         fi
389 fi
390
391 # The tree must be really really clean.
392 if ! git update-index --ignore-submodules --refresh > /dev/null; then
393         echo >&2 "cannot rebase: you have unstaged changes"
394         git diff-files --name-status -r --ignore-submodules -- >&2
395         exit 1
396 fi
397 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
398 case "$diff" in
399 ?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
400         echo >&2 "$diff"
401         exit 1
402         ;;
403 esac
404
405 if test -z "$rebase_root"
406 then
407         # The upstream head must be given.  Make sure it is valid.
408         upstream_name="$1"
409         shift
410         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
411         die "invalid upstream $upstream_name"
412         unset root_flag
413         upstream_arg="$upstream_name"
414 else
415         test -z "$newbase" && die "--root must be used with --onto"
416         unset upstream_name
417         unset upstream
418         root_flag="--root"
419         upstream_arg="$root_flag"
420 fi
421
422 # Make sure the branch to rebase onto is valid.
423 onto_name=${newbase-"$upstream_name"}
424 case "$onto_name" in
425 *...*)
426         if      left=${onto_name%...*} right=${onto_name#*...} &&
427                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
428         then
429                 case "$onto" in
430                 ?*"$LF"?*)
431                         die "$onto_name: there are more than one merge bases"
432                         ;;
433                 '')
434                         die "$onto_name: there is no merge base"
435                         ;;
436                 esac
437         else
438                 die "$onto_name: there is no merge base"
439         fi
440         ;;
441 *)
442         onto=$(git rev-parse --verify "${onto_name}^0") || exit
443         ;;
444 esac
445
446 # If a hook exists, give it a chance to interrupt
447 run_pre_rebase_hook "$upstream_arg" "$@"
448
449 # If the branch to rebase is given, that is the branch we will rebase
450 # $branch_name -- branch being rebased, or HEAD (already detached)
451 # $orig_head -- commit object name of tip of the branch before rebasing
452 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
453 switch_to=
454 case "$#" in
455 1)
456         # Is it "rebase other $branchname" or "rebase other $commit"?
457         branch_name="$1"
458         switch_to="$1"
459
460         if git show-ref --verify --quiet -- "refs/heads/$1" &&
461            branch=$(git rev-parse -q --verify "refs/heads/$1")
462         then
463                 head_name="refs/heads/$1"
464         elif branch=$(git rev-parse -q --verify "$1")
465         then
466                 head_name="detached HEAD"
467         else
468                 usage
469         fi
470         ;;
471 *)
472         # Do not need to switch branches, we are already on it.
473         if branch_name=`git symbolic-ref -q HEAD`
474         then
475                 head_name=$branch_name
476                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
477         else
478                 head_name="detached HEAD"
479                 branch_name=HEAD ;# detached
480         fi
481         branch=$(git rev-parse --verify "${branch_name}^0") || exit
482         ;;
483 esac
484 orig_head=$branch
485
486 # Now we are rebasing commits $upstream..$branch (or with --root,
487 # everything leading up to $branch) on top of $onto
488
489 # Check if we are already based on $onto with linear history,
490 # but this should be done only when upstream and onto are the same.
491 mb=$(git merge-base "$onto" "$branch")
492 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
493         # linear history?
494         ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
495 then
496         if test -z "$force_rebase"
497         then
498                 # Lazily switch to the target branch if needed...
499                 test -z "$switch_to" || git checkout "$switch_to"
500                 say "Current branch $branch_name is up to date."
501                 exit 0
502         else
503                 say "Current branch $branch_name is up to date, rebase forced."
504         fi
505 fi
506
507 # Detach HEAD and reset the tree
508 say "First, rewinding head to replay your work on top of it..."
509 git checkout -q "$onto^0" || die "could not detach HEAD"
510 git update-ref ORIG_HEAD $branch
511
512 if test -n "$diffstat"
513 then
514         if test -n "$verbose"
515         then
516                 echo "Changes from $mb to $onto:"
517         fi
518         # We want color (if set), but no pager
519         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
520 fi
521
522 # If the $onto is a proper descendant of the tip of the branch, then
523 # we just fast-forwarded.
524 if test "$mb" = "$branch"
525 then
526         say "Fast-forwarded $branch_name to $onto_name."
527         move_to_original_branch
528         exit 0
529 fi
530
531 if test -n "$rebase_root"
532 then
533         revisions="$onto..$orig_head"
534 else
535         revisions="$upstream..$orig_head"
536 fi
537
538 if test -z "$do_merge"
539 then
540         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
541                 $root_flag "$revisions" |
542         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
543         move_to_original_branch
544         ret=$?
545         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
546                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
547                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
548                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
549                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
550         exit $ret
551 fi
552
553 # start doing a rebase with git-merge
554 # this is rename-aware if the recursive (default) strategy is used
555
556 mkdir -p "$dotest"
557 echo "$onto" > "$dotest/onto"
558 echo "$onto_name" > "$dotest/onto_name"
559 prev_head=$orig_head
560 echo "$prev_head" > "$dotest/prev_head"
561 echo "$orig_head" > "$dotest/orig-head"
562 echo "$head_name" > "$dotest/head-name"
563 echo "$GIT_QUIET" > "$dotest/quiet"
564
565 msgnum=0
566 for cmt in `git rev-list --reverse --no-merges "$revisions"`
567 do
568         msgnum=$(($msgnum + 1))
569         echo "$cmt" > "$dotest/cmt.$msgnum"
570 done
571
572 echo 1 >"$dotest/msgnum"
573 echo $msgnum >"$dotest/end"
574
575 end=$msgnum
576 msgnum=1
577
578 while test "$msgnum" -le "$end"
579 do
580         call_merge "$msgnum"
581         continue_merge
582 done
583
584 finish_rb_merge